// Copyright Peter Porzsolt

var doc = app.activeDocument;
var layer = doc.layers[0];

//convert pixel to mm
var mm = 2.83464566929133;

///////////////////CUSTOMIZATION////////////////////////
var dot=10*mm;
var dotdist=17*mm; //this is the distance between edge of the banner and center of the hole
var offset=35*mm;  //this is the hemming
var target=500*mm; //target space between the center of the eyelets, actual space will be +-100mm depending of banner width

//dot color
var c=0; var m=100; var y=0; var k=0;

//donotchange
var wmm=doc.width/mm; 
var hmm=doc.height/mm;
var top=-dotdist+dot/2;
var bottom=-doc.height+dotdist+dot/2;
var left=dotdist-(dot/2);
var right=doc.width-dotdist-dot/2;

//offset layer
var rect = layer.pathItems.rectangle(offset, -offset, doc.width+offset*2, doc.height+offset*2);rect.fillColor = makeColorCMYK(0,0,0,0);
rect.stroked = true;
rect.strokeWidth = 2;

//fold line
var rect = layer.pathItems.rectangle(0, 0, doc.width, doc.height);rect.filled = false;
rect.stroked = true;
rect.strokeWidth = 0.5;
rect.opacity = 15;

//first 4 dot in each corner
var ellipse = layer.pathItems.ellipse(top, left, dot, dot); ellipse.stroked = false;ellipse.fillColor = makeColorCMYK(c,m,y,k);
var ellipse = layer.pathItems.ellipse(bottom, left, dot, dot); ellipse.stroked = false;ellipse.fillColor = makeColorCMYK(c,m,y,k);
var ellipse = layer.pathItems.ellipse(top, right, dot, dot); ellipse.stroked = false;ellipse.fillColor = makeColorCMYK(c,m,y,k);
var ellipse = layer.pathItems.ellipse(bottom, right, dot, dot); ellipse.stroked = false;ellipse.fillColor = makeColorCMYK(c,m,y,k);

//calculate how many eyelets will fit horizontally
var divided=doc.width/target;
var Hsection = Math.round(divided);

for ( var i = 1; i < Hsection; i++ ){
var ellipse = layer.pathItems.ellipse(top, ((doc.width-(dotdist*2))/Hsection)*i+(dotdist-dot/2), dot, dot); ellipse.stroked = false;ellipse.fillColor = makeColorCMYK(c,m,y,k);
var ellipse = layer.pathItems.ellipse(bottom, ((doc.width-(dotdist*2))/Hsection)*i+(dotdist-dot/2), dot, dot); ellipse.stroked = false;ellipse.fillColor = makeColorCMYK(c,m,y,k);
}



//*calculate how many eyelets will fit vertically
var divided=doc.height/target;
var Vsection = Math.round(divided);

for ( var i = 1; i < Vsection; i++ ){
var ellipse = layer.pathItems.ellipse(((-doc.height-(dotdist*2))/Vsection)*i+(dotdist-dot/2), left, dot, dot); ellipse.stroked = false;ellipse.fillColor = makeColorCMYK(c,m,y,k);
var ellipse = layer.pathItems.ellipse(((-doc.height-(dotdist*2))/Vsection)*i+(dotdist-dot/2), right, dot, dot); ellipse.stroked = false;ellipse.fillColor = makeColorCMYK(c,m,y,k);
}




// necessary since CMYKColor class has no constructor
function makeColorCMYK(c,m,y,k){
    var ink = new CMYKColor();
    ink.cyan   = c;
    ink.magenta = m;
    ink.yellow  = y;
    ink.black  = k;
    return ink;
}